clc;

% Compute Statistics as in the SAS file

% Size of price changes

deltap = log(oldprices(2:end,:)./oldprices(1:end-1,:));
p99 = prctile(abs(deltap(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & abs(deltap)>0)),99);
stemp  = share(2:end,:);
stemp  = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & abs(deltap)>0 & abs(deltap)<p99);
deltap = deltap(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & abs(deltap)>0 & abs(deltap)<p99);

fprintf('Mean delta p (non-zero)                             = %9.3f %9.3f \n', [mean(deltap),sum(deltap.*stemp)/sum(stemp)]);

stddp = sqrt(stemp'/sum(stemp)*(deltap-stemp'*deltap/sum(stemp)).^2);
fprintf('S.d. delta p (non-zero)                             = %9.3f %9.3f \n', [std(deltap),stddp]);

kurtdp  = stemp'/sum(stemp)*(deltap-stemp'*deltap/sum(stemp)).^4/stddp^4;
fprintf('Kurtosis delta p (non-zero)                         = %9.3f %9.3f \n', [kurtosis(deltap),kurtdp]);
disp(length(find(deltap)));

deltapR = log(prices(2:end,:)./prices(1:end-1,:));
pR99 = prctile(abs(deltapR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & abs(deltapR)>0)),99);

stemp  = share(2:end,:);
stemp  = stemp(prices(2:end,:)>0 & prices(1:end-1,:)>0 & abs(deltapR)>0 & abs(deltapR)<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
deltapR = deltapR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & abs(deltapR)>0 & abs(deltapR)<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
fprintf('Mean delta pR (non-zero)                            = %9.3f %9.3f \n', [mean(deltapR),sum(deltapR.*stemp)/sum(stemp)]);

stddpR = sqrt(stemp'/sum(stemp)*(deltapR-stemp'*deltapR/sum(stemp)).^2);
fprintf('S.d. delta pR (non-zero)                            = %9.3f %9.3f \n', [std(deltapR),stddpR]);

kurtdpR  = stemp'/sum(stemp)*(deltapR-stemp'*deltapR/sum(stemp)).^4/stddpR^4;
fprintf('Kurtosis delta pR (non-zero)                        = %9.3f %9.3f \n', [kurtosis(deltapR),kurtdpR]);
disp(length(find(deltapR)));


deltapS = log(oldprices(2:end,:)./oldprices(1:end-1,:));
pS99 = prctile(abs(deltapS(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& abs(deltapS)>0)),99);

stemp  = share(2:end,:);
stemp  = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& abs(deltapS)>0 & abs(deltapS)<pS99);
deltapS = deltapS(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& abs(deltapS)>0 & abs(deltapS)<pS99);
fprintf('Mean delta pS (non-zero)                            = %9.3f %9.3f \n', [mean(deltapS),sum(deltapS.*stemp)/sum(stemp)]);

stddpS = sqrt(stemp'/sum(stemp)*(deltapS-stemp'*deltapS/sum(stemp)).^2);
fprintf('S.d. delta pS (non-zero)                            = %9.3f %9.3f \n', [std(deltapS),stddpS]);

kurtdpS  = stemp'/sum(stemp)*(deltapS-stemp'*deltapS/sum(stemp)).^4/stddpS^4;
fprintf('Kurtosis delta pS (non-zero)                        = %9.3f %9.3f \n', [kurtosis(deltapS),kurtdpS]);
disp(length(find(deltapS)));

size   = abs(log(oldprices(2:end,:)./oldprices(1:end-1,:)));
stemp  = share(2:end,:);
stemp  = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<p99);
size   = size(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<p99);

fprintf('\n');
fprintf('25th 50th 75th Mean S.d. <1/2 <1/4 \n');
fprintf('\n');
fprintf('Size of price changes: unweighted                   = %9.3f %9.3f %9.3f %9.3f %9.3f  %9.3f  %9.3f \n', ...
     [prctile(size,25), prctile(size,50),prctile(size,75),mean(size), std(size), mean(size<mean(size)/2),mean(size<mean(size)/4)]);

junk = [size,stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));
fprintf('Size of price changes: weighted                     = %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f  %9.3f %9.3f \n', ...
    [max(junk(junk(:,2)<=0.10,1)),max(junk(junk(:,2)<=0.25,1)),max(junk(junk(:,2)<=0.50,1)),max(junk(junk(:,2)<=0.75,1)),max(junk(junk(:,2)<=0.90,1)),stemp'/sum(stemp)*size,...
    sqrt(stemp'/sum(stemp)*(size-stemp'/sum(stemp)*size).^2),max(junk(junk(:,1)<stemp'/sum(stemp)*size/2,2)),...
    max(junk(junk(:,1)<stemp'/sum(stemp)*size/4,2))]);



sizeR = abs(log(prices(2:end,:)./prices(1:end-1,:)));
stemp  = share(2:end,:);
stemp  = stemp(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
sizeR = sizeR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0  & sizeR<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));

fprintf('Size of R price changes                             = %9.3f %9.3f %9.3f %9.3f  %9.3f  %9.3f  %9.3f \n', ...
    [prctile(sizeR,25),prctile(sizeR,50),prctile(sizeR,75),mean(sizeR),std(sizeR), mean(sizeR<mean(sizeR)/2),mean(sizeR<mean(sizeR)/4)]);

junk = [sizeR,stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

fprintf('Size of R price changes: weighted                   = %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f  %9.3f  %9.3f  %9.3f \n', ...
    [max(junk(junk(:,2)<=0.10,1)),max(junk(junk(:,2)<=0.25,1)),max(junk(junk(:,2)<=0.50,1)),max(junk(junk(:,2)<=0.75,1)),max(junk(junk(:,2)<=0.90,1)),stemp'/sum(stemp)*sizeR,...
    sqrt(stemp'/sum(stemp)*(sizeR-stemp'/sum(stemp)*sizeR).^2),max(junk(junk(:,1)<stemp'/sum(stemp)*sizeR/2,2)),...
    max(junk(junk(:,1)<stemp'/sum(stemp)*sizeR/4,2))]);


sizeS = abs(log(oldprices(2:end,:)./oldprices(1:end-1,:)));
stemp  = share(2:end,:);
stemp  = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& sizeS>0 & sizeS<pS99);
sizeS = sizeS(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& sizeS>0 & sizeS<pS99);

fprintf('Size of S price changes                             = %9.3f %9.3f %9.3f %9.3f  %9.3f  %9.3f  %9.3f \n', ...
    [prctile(sizeS,25),prctile(sizeS,50),prctile(sizeS,75),mean(sizeS),std(sizeS), mean(sizeS<mean(sizeS)/2),mean(sizeS<mean(sizeS)/4)]);

junk = [sizeS,stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

fprintf('Size of S price changes: weighted                   = %9.3f %9.3f %9.3f %9.3f %9.3f %9.3f  %9.3f  %9.3f  %9.3f \n', ...
    [max(junk(junk(:,2)<=0.10,1)),max(junk(junk(:,2)<=0.25,1)),max(junk(junk(:,2)<=0.50,1)),max(junk(junk(:,2)<=0.75,1)),max(junk(junk(:,2)<=0.90,1)),stemp'/sum(stemp)*sizeS,...
    sqrt(stemp'/sum(stemp)*(sizeS-stemp'/sum(stemp)*sizeS).^2),max(junk(junk(:,1)<stemp'/sum(stemp)*sizeS/2,2)),...
    max(junk(junk(:,1)<stemp'/sum(stemp)*sizeS/4,2))]);


% Fraction of variance accounted for by heterogeneity
upc = allupc';
man=floor(upc/100000);  
man(man>100000)=man(man>100000)-floor(man(man>100000)/100000)*100000;
[group,ii,jj] = unique([man,allcat'],'rows');    %unique manufacturer-product category

jju = unique(jj);

meanp = zeros(length(jju),1);
meanR = meanp;
meanS = meanp;

id = repmat(jj',T-1,1);                          %unique manufacturer-product category for each date to match with size
idold = repmat((1:1:K)',T-1,1);

size   = abs(log(oldprices(2:end,:)./oldprices(1:end-1,:)));
idp = id(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<p99);
idpold = idold(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<p99);
stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<p99);
size = size(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<p99);
meanallp = stemp'/sum(stemp)*size;

sizeR = abs(log(prices(2:end,:)./prices(1:end-1,:)));
idR   = id(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
idRold = idold(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
stemp = share(2:end,:);
stemp = stemp(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
sizeR = sizeR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<pR99 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
meanallR = stemp'/sum(stemp)*sizeR;

sizeS = abs(log(oldprices(2:end,:)./oldprices(1:end-1,:)));
idS = id(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& sizeS>0 & sizeS<pS99);
idSold = idold(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& sizeS>0 & sizeS<pS99);
stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& sizeS>0 & sizeS<pS99);
sizeS =sizeS(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & ...
    (((oldprices(2:end,:)==prices(2:end,:)& oldprices(1:end-1,:)<prices(1:end-1,:))|...
    (oldprices(1:end-1,:)==prices(1:end-1,:)& oldprices(2:end,:)<prices(2:end,:))))& sizeS>0 & sizeS<pS99);
meanallS = stemp'/sum(stemp)*sizeS;


stdsize  = size;
stdsizeR = sizeR;
stdsizeS = sizeS;
stddeltap = deltap;
stddeltapR = deltapR;
stddeltapS = deltapS;


for i = 1: length(jju)
    
    if length(find(idp ==jju(i)))>10
        meanp(i) = mean(size(idp==jju(i)));
        stdsize(idp==jju(i)) = size(idp==jju(i))/meanp(i)*meanallp;
        stddeltap(idp==jju(i)) = deltap(idp==jju(i))/meanp(i)*meanallp;
    else
        stdsize(idp==jju(i))=0;
        size(idp==jju(i))=0;
        stddeltap(idp==jju(i))=0;
    end
    
    if length(find(idR ==jju(i)))>10
        meanR(i) = mean(sizeR(idR==jju(i)));
        stdsizeR(idR ==jju(i)) = sizeR(idR==jju(i))/meanR(i)*meanallR;
        stddeltapR(idR==jju(i)) = deltapR(idR==jju(i))/meanR(i)*meanallR;
    else
        stdsizeR(idR==jju(i))=0;
        sizeR(idR==jju(i))=0;
        stddeltapR(idR==jju(i))=0;
    end
    
     if length(find(idS ==jju(i)))>10
        meanS(i) = mean(sizeS(idS==jju(i)));
        stdsizeS(idS==jju(i)) = sizeS(idS==jju(i))/meanS(i);
        stddeltapS(idS==jju(i)) = deltapS(idS==jju(i))/meanS(i)*meanallR;
     else
         stdsizeS(idS==jju(i))=0;
         sizeS(idS==jju(i))=0;
         stddeltapS(idS==jju(i))=0;
     end
    
end

fprintf('Fraction of variance due to good-specific effects         = %9.3f %9.3f %9.3f \n', [var(meanp(meanp>0))/var(size(size>0)),...
    var(meanR(meanR>0))/var(sizeR(sizeR>0)),var(meanS(meanS>0))/var(sizeS(sizeS>0))]);

fprintf('Coefficient of variation of size of delta p: unweight     = %9.3f %9.3f %9.3f \n', [std(stdsize(stdsize>0))/mean(stdsize(stdsize>0)),...
    std(stdsizeR(stdsizeR>0))/mean(stdsizeR(stdsizeR>0)),std(stdsizeS(stdsizeS>0))/mean(stdsizeS(stdsizeS>0))]);

% Switch id back to goods to compute weighted 


idp = idpold;
idR = idRold;
idS = idSold;

stemp = share(1,:)';
stemp = stemp(idp);
stemp = stemp(stdsize>0);
stdsize = stdsize(stdsize>0);

cv = sqrt(stemp'/sum(stemp)*(stdsize-stemp'/sum(stemp)*stdsize).^2)/(stemp'/sum(stemp)*stdsize);


stemp = share(1,:)';
stemp = stemp(idR);
stemp = stemp(stdsizeR>0);
stdsizeR = stdsizeR(stdsizeR>0);

cvR = sqrt(stemp'/sum(stemp)*(stdsizeR-stemp'/sum(stemp)*stdsizeR).^2)/(stemp'/sum(stemp)*stdsizeR);


stemp = share(1,:)';
stemp = stemp(idS);
stemp = stemp(stdsizeS>0);
stdsizeS = stdsizeS(stdsizeS>0);

cvS = sqrt(stemp'/sum(stemp)*(stdsizeS-stemp'/sum(stemp)*stdsizeS).^2)/(stemp'/sum(stemp)*stdsizeS);


fprintf('Coefficient of variation of size of delta p: weight        = %9.3f %9.3f %9.3f \n', [cv, cvR, cvS]);


stemp = share(1,:)';
stemp = stemp(idp);
stemp = stemp(abs(stddeltap)>0 & abs(stddeltap)<p99);
stddeltap = stddeltap(abs(stddeltap)>0 &  abs(stddeltap)<p99);
meandp = stemp'*abs(stddeltap/sum(stemp));
stddp  = sqrt(stemp'/sum(stemp)*(stddeltap-stemp'*stddeltap/sum(stemp)).^2);
kurtdp = stemp'/sum(stemp)*(stddeltap-stemp'*stddeltap/sum(stemp)).^4/stddp^4;

junk = [abs(stddeltap),stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

fprintf('Fraction delta p <1/2, 1/4 mean       = %9.3f  %9.3f \n', ...
    [max(junk(junk(:,1)<meandp/2,2)),  max(junk(junk(:,1)<meandp/4,2))]);
fprintf('25th and 75th percentile abs deltap = %9.3f %9.3f %9.3f %9.3f  %9.3f \n', [min(junk(junk(:,2)>=0.10,1)),min(junk(junk(:,2)>=0.25,1)),min(junk(junk(:,2)>=0.50,1)),min(junk(junk(:,2)>=0.75,1)),min(junk(junk(:,2)>=0.90,1))]);

stemp = share(1,:)';
stemp = stemp(idR);
stemp = stemp(abs(stddeltapR)>0 & abs(stddeltapR)<pR99);
stddeltapR = stddeltapR(abs(stddeltapR)>0 &  abs(stddeltapR)<pR99);
meandR = stemp'*abs(stddeltapR)/sum(stemp);
stddR  = sqrt(stemp'/sum(stemp)*(stddeltapR-stemp'*stddeltapR/sum(stemp)).^2);
kurtdR = stemp'/sum(stemp)*(stddeltapR-stemp'*stddeltapR/sum(stemp)).^4/stddR^4;

junk = [abs(stddeltapR),stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

fprintf('Fraction delta pR <1/2, 1/4 mean       = %9.3f  %9.3f \n', ...
    [max(junk(junk(:,1)<meandR/2,2)),  max(junk(junk(:,1)<meandR/4,2))]);
fprintf('25th and 75th percentile abs deltapR = %9.3f %9.3f %9.3f %9.3f  %9.3f \n', [min(junk(junk(:,2)>=0.10,1)),min(junk(junk(:,2)>=0.25,1)),min(junk(junk(:,2)>=0.50,1)),min(junk(junk(:,2)>=0.75,1)),min(junk(junk(:,2)>=0.90,1))]);


stemp = share(1,:)';
stemp = stemp(idS);
stemp = stemp(abs(stddeltapS)>0 & abs(stddeltapS)<pS99);
stddeltapS = stddeltapS(abs(stddeltapS)>0 &  abs(stddeltapS)<pS99);
meandS  = stemp'*abs(stddeltapS)/sum(stemp);
stddS   = sqrt(stemp'/sum(stemp)*(stddeltapS-stemp'*stddeltapS/sum(stemp)).^2);
kurtdS  = stemp'/sum(stemp)*(stddeltapS-stemp'*stddeltapS/sum(stemp)).^4/stddS^4;


junk = [abs(stddeltapS),stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

fprintf('Fraction delta pR <1/2, 1/4 mean       = %9.3f  %9.3f \n', ...
    [max(junk(junk(:,1)<meandS/2,2)),  max(junk(junk(:,1)<meandS/4,2))]);

fprintf('25th and 75th percentile abs deltapS = %9.3f %9.3f %9.3f %9.3f  %9.3f \n', [min(junk(junk(:,2)>=0.10,1)),min(junk(junk(:,2)>=0.25,1)),min(junk(junk(:,2)>=0.50,1)),min(junk(junk(:,2)>=0.75,1)),min(junk(junk(:,2)>=0.90,1))]);


fprintf('Kurtosis delta p (non-zero)                         = %9.3f %9.3f \n', [kurtosis(stddeltap),kurtdp]);
fprintf('Kurtosis delta pR (non-zero)                        = %9.3f %9.3f \n', [kurtosis(stddeltapR),kurtdR]);
fprintf('Kurtosis delta pS (non-zero)                        = %9.3f %9.3f \n', [kurtosis(stddeltapS),kurtdS]);




change = oldprices(2:end,:)~=oldprices(1:end-1,:);
change = change(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Frequency of price changes                          = %9.3f %9.3f \n', [mean(change),sum(change.*stemp)/sum(stemp)]);

changeT = (oldprices(2:end,:)~=prices(2:end,:) | oldprices(1:end-1,:)~=prices(1:end-1,:)& oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0) & ...
    oldprices(2:end,:)~=oldprices(1:end-1,:);
changeT = changeT(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Frequency of temp price changes                     = %9.3f %9.3f \n', [mean(changeT),sum(changeT.*stemp)/sum(stemp)]);


changeR = prices(2:end,:)~=prices(1:end-1,:);
changeR = changeR(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Frequency of reg price changes                      = %9.3f %9.3f \n', [mean(changeR),sum(changeR.*stemp)/sum(stemp)]);


temp = oldprices(1:end-1,:)~=prices(1:end-1,:);
temp = temp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Fraction of prices that are temporary               = %9.3f %9.3f \n', [mean(temp),sum(temp.*stemp)/sum(stemp)]);

ret = prices(2:end,:)==oldprices(2:end,:) & prices(1:end-1,:)~=oldprices(1:end-1,:);
ret = ret(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Fraction of returns                                 = %9.3f %9.3f \n', [mean(ret),sum(ret.*stemp)/sum(stemp)]);

retold = (prices(2:end,:)==oldprices(2:end,:) & prices(1:end-1,:)~=oldprices(1:end-1,:)) & prices(2:end,:)==prices(1:end-1,:);
retold = retold(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Fraction of returns to old price                    = %9.3f %9.3f \n', [mean(retold),sum(retold.*stemp)/sum(stemp)]);

tempabove = oldprices(1:end-1,:)>prices(1:end-1,:);
tempabove = tempabove(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Fraction of prices above regular price              = %9.3f %9.3f \n', [mean(tempabove),sum(tempabove.*stemp)/sum(stemp)]);

tempbelow = oldprices(1:end-1,:) < prices(1:end-1,:);
tempbelow = tempbelow(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

fprintf('Fraction of prices below regular price              = %9.3f %9.3f \n', [mean(tempbelow),sum(tempbelow.*stemp)/sum(stemp)]);

q = allq(1:end-1,:);
soldbelow = q(oldprices(1:end-1,:) < prices(1:end-1,:) & oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0);
sold =      q(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 );

fprintf('Fraction of goods below regular price              = %9.3f  \n', [sum(soldbelow)/sum(sold)]);

% Compute annual mode

lyear = 50;

modes=zeros(T/lyear,K);

fmode  = modes;
fbelow = modes;
fabove = modes;

for i=1:K
    
    for year=1:T/lyear % a year is 50 months
        
        junk=oldprices((year-1)*lyear+1:year*lyear,i);      % year = 12 months
        junk=junk(junk>0);
        if length(find(junk))>.6*lyear;                     % must be in at least 60% of the time
           
            modes(year,i)  = mode(junk);
            fmode(year,i)  = mean(junk==mode(junk));
            fbelow(year,i) = mean(junk<mode(junk));
            fabove(year,i) = mean(junk>mode(junk));
       
        end
    end
end


fmode  = fmode(modes>0);
fbelow = fbelow(modes>0);
fabove = fabove(modes>0);
stemp  = repmat(share(1,:),T/lyear,1);
stemp  = stemp(modes>0);

fprintf('\n');
fprintf('Fraction at annual mode                             = %9.3f %9.3f \n', [mean(fmode), stemp'/sum(stemp)*fmode]);
fprintf('Fraction below annual mode                          = %9.3f %9.3f \n', [mean(fbelow),stemp'/sum(stemp)*fbelow]);
fprintf('Fraction above annual mode                          = %9.3f %9.3f \n', [mean(fabove),stemp'/sum(stemp)*fabove]);

changeM = modes(2:end,:) ~= modes(1:end-1,:);
changeM = changeM(modes(2:end,:)>0&modes(1:end-1,:)>0);

stemp = repmat(share(1,:), T/lyear-1,1);
stemp = stemp(modes(2:end,:)>0 & modes(1:end-1,:)>0);

fprintf('Frequency with which mode changes                   = %9.3f %9.3f \n', [mean(changeM),stemp'/sum(stemp)*changeM]);



% Compute quarterly mode

lyear = 12;
T = T-4;
oldprices(1:4,:)=[];

modes=zeros(T/lyear,K);

fmode  = modes;
fbelow = modes;
fabove = modes;

for i=1:K
    
    for year=1:T/lyear % a year is 50 months
        
        junk=oldprices((year-1)*lyear+1:year*lyear,i);      % year = 12 months
        junk=junk(junk>0);
        if length(find(junk))>.6*lyear;                     % must be in at least 60% of the time
           
            modes(year,i)  = mode(junk);
            fmode(year,i)  = mean(junk==mode(junk));
            fbelow(year,i) = mean(junk<mode(junk));
            fabove(year,i) = mean(junk>mode(junk));
       
        end
    end
end


fmode  = fmode(modes>0);
fbelow = fbelow(modes>0);
fabove = fabove(modes>0);
stemp  = repmat(share(1,:),T/lyear,1);
stemp  = stemp(modes>0);

fprintf('\n');
fprintf('Fraction at quarterly mode                             = %9.3f %9.3f \n', [mean(fmode), stemp'/sum(stemp)*fmode]);
fprintf('Fraction below quarterly mode                          = %9.3f %9.3f \n', [mean(fbelow),stemp'/sum(stemp)*fbelow]);
fprintf('Fraction above quarterlu mode                          = %9.3f %9.3f \n', [mean(fabove),stemp'/sum(stemp)*fabove]);

changeM = modes(2:end,:) ~= modes(1:end-1,:);
changeM = changeM(modes(2:end,:)>0&modes(1:end-1,:)>0);

stemp = repmat(share(1,:), T/lyear-1,1);
stemp = stemp(modes(2:end,:)>0 & modes(1:end-1,:)>0);

fprintf('Frequency with which mode changes                   = %9.3f %9.3f \n', [mean(changeM),stemp'/sum(stemp)*changeM]);


