disp('simulating...');
T = 830;
N = 2500;

lambda = 1 - 0.0545;

mu    = zeros(N,T);
p     = zeros(N,T);



M = ones(T,1);
g = zeros(T,1);
eg = randn(T,1)*sshock;

randn('state',0);
rand('state',0);

for t = 1:T
    if t==1
        p(:,t) = ones(N,1);
    else
        g(t) = rog*g(t-1)+eg(t);
        M(t) = M(t-1)*exp(g(t));
        lucky = rand(N,1)>lambda;       
        p(:,t)= lucky.*M(t)*exp(lambda*beta*rog/(1-lambda*beta*rog)*g(t))+ (1-lucky).*p(:,t-1);
        
    end
end

AA = (1-beta*rog)/(1-lambda*beta*rog);
Cc = zeros(T,1);

%lambda = 0.9682;
%AA = 0.6078/lambda;
for t = 2:T
    
    Cc(t) = lambda*Cc(t-1) + lambda*AA*g(t);
end

p(:,1:30)=[];
Cc(1:30)=[];
g(1:30)=[];

T = T-30;
P = (mean(p.^(1-gamma)).^(1/(1-gamma)))';

lyear = 50;

modes=zeros(T/lyear,N);

fmode  = modes;


for i=1:N
    
    for year=1:T/lyear % a year is 50 months
       junk=p(i,(year-1)*lyear+1:year*lyear);      
       fmode(year,i)  = mean(junk==mode(junk));
   
    end
end
disp(mean(fmode(:)))


   Ccm = reshape(Cc,4,T/4); Ccm = exp(Ccm); Ccm = sum(Ccm)'; Ccm = log(Ccm/4);
  
  
  
   [Cct,Ccd] = hptrend(Ccm,14400);
disp(std(Ccd)*100);
break

% Calvo
  
Cc = zeros(T,1);

alphaR = mean(FadjR);
alphaT = mean(FadjP);

AA = (1-alphaT-alphaR)*beta/(1-alphaT*beta)*rog/(1-(1-alphaR)*beta*rog);

for t = 2:T
   
    Cc(t) = -alphaR*AA*(g(t)-alphaT*g(t-1))+(1-alphaR-alphaT)*g(t)+(1-alphaR)*Cc(t-1);
    
end

   C = log(M./P)-log(1./Pf);

   figure(1)
   plot(log(P/P(1))-log(Pf/Pf(1)));
   hold on
   plot(log(M/M(1)),'r')
   figure(2)
   plot([C,Cc])
   
   C(1:30)=[];
   Cc(1:30)=[];
   P(1:30)=[];
   M(1:30)=[];
   Pf(1:30)=[];
   g(1:30)=[];
   T = T-30;
   FadjR(1:30)=[];
   
   Cm = reshape(C',4,T/4);   Cm = exp(Cm); Cm = sum(Cm)';   Cm = log(Cm/4);
   Ccm = reshape(Cc,4,T/4); Ccm = exp(Ccm); Ccm = sum(Ccm)'; Ccm = log(Ccm/4);
  
   pai = log(P(2:end)./P(1:end-1)./Pf(2:end).*Pf(1:end-1));
   DP = pai./FadjR(2:end);
   
  
   [Ct,Cd] = hptrend(Cm,14400);
   [Cct,Ccd] = hptrend(Ccm,14400);
   
   % Krusell Smith 
   
   Pk = log(P)-log(Pf)-log(M);
   Pk = Pk - mean(Pk);
  
   ckrusold = ckrus;
   
   reg = ols(Pk(2:end),[ones(size(Pk(2:end))),g(2:end),Pk(1:end-1)]);
   ckrus = reg.beta; 
   
   regc = ols(-Cc(2:end),[ones(size(Cc(2:end))),g(2:end),-Cc(1:end-1)]);
   
   disp('Aggregate Statistics: menu costs')
   [reg.rsqr,reg.beta(2:end)',corr([Cd(1:end-1),Cd(2:end)]),std(Cd)]
   
   disp('Aggregate Statistics: calvo')
   [regc.rsqr,regc.beta(2:end)',corr([Ccd(1:end-1),Ccd(2:end)]),std(Ccd)]
   
   disp('KK statistics')
   [var(DP)*mean(FadjR).^2/var(pai), corr([FadjR(2:end),abs(pai)])]
   
   
   disp('Errors in Krusell Smith coefficients') 
   norm(ckrusold-ckrus)
   
   save ckrus ckrus;
