clear;
clc;
format short;

global gamma mua ha;

%Assigned Parameters: 

gamma  = 3;                  % elasticity between retailers
mua    = 0;
ha     = 0;

% CALIBRATED PARAMETERS

sa     = 0.0826;             % std. dev. of permanent productivity shocks
saa    = 0.8227;                % covariance of productivity shocks
alpha  = 0.1287;           % frequency of v shocks
rho    = 0.5415;           % probability stay in high z state
zbar   = 0.3079;           % max size of transitory productivity shocks
phiR   = 0.0196;            % menu costs for regular prices
kappa  = 0.0108;           % cost of deviating from regular price
pshock = 0.0365; 

% mean growth of a

%Bounds for parameters:

lb = [0.05;  0.6;  0.1;  .3;   0.2; 0.01;  0.005; 0.02];          
ub = [0.15;  1.3;  0.3;  .7;   0.4; 0.06;  0.03;  0.08];

%guess for calibrated parameters 

xstart=[sa; saa; alpha; rho; zbar; phiR; kappa; pshock];

% objective(xstart)
% break
% Code for use by Tomlab
% Name = 'Model 1';
% Prob = glcAssign('objective',lb,ub,Name);
% tomRun('ego',Prob,3)

i = 2;

if i==1
x = fmincon('objective',xstart,[],[],[],[],lb,ub);
    else
x = neldmead_bounds('objective',xstart,lb,ub);
end

save x x
