clear;
clc;
format short;

global gamma mua ha;

%Assigned Parameters: 
   
gamma  = 3;               % elasticity between retailers
mua    = 0;  
ha     = 0;

sa      = 0.1372;         % max size productivity shocks
phiR    = 0.2288;         % menu costs for regular prices
pshock  = 0.089;
pphi    = 0.0305;

%Bounds for parameters:

lb = [0.09; 0.05; 0.05; 0.01];          
ub = [0.18; 2;    0.15; 0.08];

%guess for calibrated parameters 

xstart=[sa; phiR; pshock; pphi];

% objective(xstart)
%  break
% Code for use by Tomlab
% Name = 'Model 1';
% Prob = glcAssign('objective',lb,ub,Name);
% tomRun('ego',Prob,3)

i = 2;

if i==1
x = fmincon('objective',xstart,[],[],[],[],lb,ub);
    else
x = neldmead_bounds('objective',xstart,lb,ub);
end

save x x
