clear;
clc;
format short;

global gamma mua ha;

%Assigned Parameters: 
   
gamma  = 3;                % elasticity between retailers
mua    = 0;  
ha     = 0;

sa     = 0.1094;           % max size productivity shocks
saa    = 0.4661;           % covariance of productivity shocks (weight on mean)
phiR   = 0.0107;          % menu costs for regular prices
pshock = 0.0786;

            

%Bounds for parameters:

lb = [0.04; 0.1; 0.005; 0.03];          
ub = [0.17; 0.9; 0.030; 0.15];

%guess for calibrated parameters 

xstart=[sa; saa; phiR; pshock];

% objective(xstart)
%  break
% Code for use by Tomlab
% Name = 'Model 1';
% Prob = glcAssign('objective',lb,ub,Name);
% tomRun('ego',Prob,3)

i = 2;

if i==1
x = fmincon('objective',xstart,[],[],[],[],lb,ub);
    else
x = neldmead_bounds('objective',xstart,lb,ub);
end

save x x
