clear;
clc;
format short;

global gamma mua;

%Assigned Parameters: 
   
gamma  = 3;                 % elasticity between retailers
mua    = -0.15/100*0;  

sa     = 0.2003;             % max size productivity shocks
saa    = 0.8361;           % covariance of productivity shocks (weight on mean)
phiR   = 0.0406;           % menu costs for regular prices
alpha1 = 0.0275;
alpha2 = 1.1036;
prup   = 0.2815;


%Bounds for parameters:

lb = [0.1; 0.6; 0.01; 0.02;  .7;  .2];          
ub = [0.3; 1.5; 0.08; 0.10;  1.3; .5];

%guess for calibrated parameters 

xstart=[sa; saa; phiR; alpha1; alpha2; prup];

% objective(xstart)
%  break
% Code for use by Tomlab
% Name = 'Model 1';
% Prob = glcAssign('objective',lb,ub,Name);
% tomRun('ego',Prob,3)

i = 2;

if i==1
x = fmincon('objective',xstart,[],[],[],[],lb,ub);
    else
x = neldmead_bounds('objective',xstart,lb,ub);
end

save x x
