var  Delta k p gc omega c w  r rk g y l i;
varexo eps;


parameters gamma rhom beta alpha delta eta rbar cw kybar cybar xaiK ck cp cg;

% Assigned parameters

beta   = 0.96^(1/12);
gamma  =    3;
rhom   = 0.61;
se     = 0.0018;
alpha  = 0.67;
delta  = 0.01;
rbar   = 1/beta-1+delta;
cw     = alpha^alpha*(1-alpha)^(1-alpha);
kybar  = (1-alpha)*(gamma-1)/gamma*1/(1/beta-1+delta);
cybar  = 1-delta*kybar;
eta    = 1.9;
xaiK   = 25;

load pars;

cg     = pars(1);
cp     = pars(2);
ck     = pars(3);




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  MODEL  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;

p = ck*k(-1)+cp*p(-1)+cg*g;
c = w-p;
0 = r+c-c(+1)+p-p(+1)-g(+1);
omega = alpha*w+(1-alpha)*p+(1-alpha)*rk;
(c(+1)-c)*(1+delta*xaiK)+xaiK*(k-(1-delta)*k(-1)) = beta*(rbar*rk(+1)+(1-delta)*xaiK*(k(+1)-(1-delta)*k));
p+c = eta/beta*r;
g   = rhom*g(-1)+eps;
cybar*c+kybar*k-(1-delta)*kybar*k(-1) = y;
omega+y-l = w;
omega+y-k(-1) = p+rk;
Delta = omega-p;
gc=omega(+1)-omega+g(+1);
i = 1/delta*(k-(1-delta)*k(-1));
end;

shocks; 
var eps = se^2;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  END MODEL   %%%%%%%%%%%%%%%%%%%%%%%%%%%%


initval;

p=0;
c=0;
w=0;
omega=0;
rk =0;
r=0;
g=0;
k=0;
y=0;
l=0;
Delta=0;
gc =0;
i =0;

end;

steady;
stoch_simul(linear, HP_filter = 14400, irf = 0);

