var  x p c w omega r rk g k y l;
varexo eps;
global verga;
parameters lambda gamma rhom beta alpha delta eta rbar cw kybar cybar;

% Assigned parameters


beta   = 0.96^(1/12);
gamma  = 3;
lambda = 0.9;
rhom   = 0.61;
se     = 0.0018;
alpha  = 0.67;
delta  = 0.01;
rbar   = 1/beta-1+delta;
cw     = alpha^alpha*(1-alpha)^(1-alpha);
kybar  = (1-alpha)*cw*(gamma-1)/gamma*1/(1/beta-1+delta);
cybar  = 1-delta*kybar;
eta    = 1.9;
 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  MODEL  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;


x = lambda*beta*x(+1)+(1-lambda*beta)*omega+lambda*beta*rhom*g;
p = lambda*(p(-1)-g)+(1-lambda)*x;
c = w-p;
0 = r+c-c(+1)+p-p(+1)-g(+1);
omega = alpha*w+(1-alpha)*p+(1-alpha)*rk;
c(+1)-c = beta*rbar*rk(+1);
p+c = eta/beta*r;
g   = rhom*g(-1)+eps;
cybar*c+kybar*k-(1-delta)*kybar*k(-1) = y;
omega+y-l = w;
omega+y-k(-1) = p+rk;
end;

shocks; 
var eps = se^2;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  END MODEL   %%%%%%%%%%%%%%%%%%%%%%%%%%%%


initval;

x=0;
p=0;
c=0;
w=0;
omega=0;
rk =0;
r=0;
g=0;
k=0;
y=0;
l=0;
end;

steady;
stoch_simul(linear);

