var  Delta k p gc omega c w  r rk g y l i m gdp;
varexo eps;


parameters gamma rhom beta alpha delta eta rbar cw kybar cybar mybar xaiK ck cp cg nu ;

% Assigned parameters

beta   = 0.96^(1/12);
gamma  =    3;
rhom   = 0.61;
se     = 0.0018;
alpha  = 2/3*(1-2/3);
nu     = 1/3*(1-2/3);
delta  = 0.01;
rbar   = 1/beta-1+delta;
cw     = alpha^alpha*(1-alpha)^(1-alpha);
kybar  = nu*(gamma-1)/gamma*1/(1/beta-1+delta);
mybar  = (1-alpha-nu)*(gamma-1)/gamma;
cybar  = 1-delta*kybar-mybar;
eta    = 1.9;
xaiK   = 29;

load pars;

cg     = pars(1);
cp     = pars(2);
ck     = pars(3);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  MODEL  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;

p = ck*k(-1)+cp*p(-1)+cg*g;
c = w-p;
0 = r+c-c(+1)+p-p(+1)-g(+1);
omega = alpha*w+nu*p+nu*rk+(1-alpha-nu)*p;
(c(+1)-c)*(1+delta*xaiK)+xaiK*(k-(1-delta)*k(-1)) = beta*(rbar*rk(+1)+(1-delta)*xaiK*(k(+1)-(1-delta)*k));
p+c = eta/beta*r;
g   = rhom*g(-1)+eps;
cybar*c+kybar*k-(1-delta)*kybar*k(-1)+mybar*m = y;
omega+y-l = w;
omega+y-k(-1) = p+rk;
omega+y-m = p;
Delta = omega-p;
gc=omega(+1)-omega+g(+1);
i = 1/delta*(k-(1-delta)*k(-1));
gdp = (cybar*c+kybar*k-(1-delta)*kybar*k(-1))*(cybar+delta*kybar)^(-1);
end;

shocks; 
var eps = se^2;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  END MODEL   %%%%%%%%%%%%%%%%%%%%%%%%%%%%


initval;

p=0;
c=0;
w=0;
omega=0;
rk =0;
r=0;
g=0;
k=0;
y=0;
l=0;
Delta=0;
gc =0;
i =0;

end;

steady;
stoch_simul(linear, HP_filter = 14400, irf = 0);

