var  p c w omega r rk g k y l;
varexo eps;

parameters lambda gamma rhom beta alpha delta eta rbar cw kybar cybar;

% Assigned parameters

beta   = 0.96^(1/12);
gamma  = 3;
rhom   = 0.61;
se     = 0.0018;
alpha  = 0.67;
delta  = 0.01;
rbar   = 1/beta-1+delta;
cw     = alpha^alpha*(1-alpha)^(1-alpha);
kybar  = (1-alpha)*cw*(gamma-1)/gamma*1/(1/beta-1+delta);
cybar  = 1-delta*kybar;
eta    = 1.9;
%x = lambda*beta*x(+1)+(1-lambda*beta)*omega+lambda*beta*rhom*g;
%p = lambda*(p(-1)-g)+(1-lambda)*x;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  MODEL  %%%%%%%%%%%%%%%%%%%%%%%%%%%%
model;


1 = beta*exp(r)*exp(c)/exp(c(+1))*exp(p)/exp(p(+1))/exp(g(+1));
exp(c(+1))/exp(c)=beta*(exp(rk(+1))+(1-delta));
exp(p)=gamma/(gamma-1)*exp(omega);
exp(c) = exp(w)/exp(p);
exp(omega)=exp(w)^alpha*(exp(p)*exp(rk))^(1-alpha);
p+c=eta*(exp(r)-1);
g = rhom*g(-1)+eps;
exp(c)+exp(k)-(1-delta)*exp(k(-1))=exp(y);
exp(omega)*alpha*cw*exp(y-l)=exp(w);
exp(omega)*(1-alpha)*cw*exp(y-k(-1))=exp(p+rk);
end;

shocks; 
var eps = se^2;
end;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  END MODEL   %%%%%%%%%%%%%%%%%%%%%%%%%%%%


initval;
r = log(1/beta);
rk = log(1/beta-1+delta);
w = eta*log(1-beta);
omega = ((1-alpha)/alpha)*log(gamma/(gamma-1))+w+(1-alpha)/alpha*rk;
p=log(gamma/(gamma-1))+omega;
c = w-p;
k = log((1-alpha)*cw*exp(c)/(exp(p+rk-omega)-(1-alpha)*cw*delta));
y = log(exp(c)+delta*exp(k));
l = log(alpha*cw*exp(y-w+omega));
g = 0;
end;

steady;
stoch_simul(linear);

