clc;

% Compute Statistics as in the SAS file

% Size of price changes

size   = abs(log(oldprices(2:end,:)./oldprices(1:end-1,:)));
stemp  = share(2:end,:);
stemp  = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<1);
size   = size(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<1);

Meansize = stemp'/sum(stemp)*size;

sizeR = abs(log(prices(2:end,:)./prices(1:end-1,:)));
stemp  = share(2:end,:);
stemp  = stemp(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<1 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:) );
sizeR  = sizeR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<1 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));

MeansizeR = stemp'/sum(stemp)*sizeR;

% Compute standardized price changes

meanp = zeros(K,1);
meanR = zeros(K,1);
meanS = zeros(K,1);

id = repmat((1:1:K),T-1,1);

size   = abs(log(oldprices(2:end,:)./oldprices(1:end-1,:)));
idp = id(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<1);
stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<1);
size = size(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & size>0 & size<1);
meanallp = stemp'/sum(stemp)*size;

sizeR = abs(log(prices(2:end,:)./prices(1:end-1,:)));
idR = id(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<1 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
stemp = share(2:end,:);
stemp = stemp(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<1 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
sizeR = sizeR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & sizeR>0 & sizeR<1 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));
meanallR = stemp'/sum(stemp)*sizeR;


deltap = log(oldprices(2:end,:)./oldprices(1:end-1,:));
deltap = deltap(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0 & abs(deltap)>0 & abs(deltap)<1);


deltapR = log(prices(2:end,:)./prices(1:end-1,:));
deltapR = deltapR(prices(2:end,:)>0 & prices(1:end-1,:)>0 & abs(deltapR)>0 & abs(deltapR)<1 & prices(2:end,:)==oldprices(2:end,:)& prices(1:end-1,:)==oldprices(1:end-1,:));

stdsize  = size;
stdsizeR = sizeR;
stddeltap = deltap;
stddeltapR = deltapR;

for i = 1: K
    
    if length(find(idp ==i))>5
        meanp(i) = mean(size(idp==i));
        stdsize(idp==i) = size(idp==i)/meanp(i)*meanallp;
        stddeltap(idp==i) = deltap(idp==i)/meanp(i)*meanallp;
    else
        stdsize(idp==i)=0;
        size(idp==i)=0;
        stddeltap(idp==i)=0;
    end
    
    if length(find(idR ==i))>5
        meanR(i) = mean(sizeR(idR==i));
        stdsizeR(idR ==i) = sizeR(idR==i)/meanR(i)*meanallR;
        stddeltapR(idR==i) = deltapR(idR==i)/meanR(i)*meanallR;
    else
        stdsizeR(idR==i)=0;
        sizeR(idR==i)=0;
        stddeltapR(idR==i)=0;
    end
    
     
end

stemp = share(1,:)';
stemp = stemp(idp);
stemp = stemp(stdsize>0);
stdsize = stdsize(stdsize>0);

SD = sqrt(stemp'/sum(stemp)*(stdsize-stemp'/sum(stemp)*stdsize).^2);

stemp = share(1,:)';
stemp = stemp(idR);
stemp = stemp(stdsizeR>0);
stdsizeR = stdsizeR(stdsizeR>0);

SDR = sqrt(stemp'/sum(stemp)*(stdsizeR-stemp'/sum(stemp)*stdsizeR).^2);

stemp = share(1,:)';
stemp = stemp(idp);
stemp = stemp(abs(stddeltap)>0 & abs(stddeltap)<1);
stddeltap = stddeltap(abs(stddeltap)>0 &  abs(stddeltap)<1);
meandp = stemp'*abs(stddeltap/sum(stemp));
stddp  = sqrt(stemp'/sum(stemp)*(stddeltap-stemp'*stddeltap/sum(stemp)).^2);
kurtdp = stemp'/sum(stemp)*(stddeltap-stemp'*stddeltap/sum(stemp)).^4/stddp^4;

junk = [abs(stddeltap),stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

f2 = max(junk(junk(:,1)<meandp/2,2)); if isempty(f2); f2=0; end;
f4 = max(junk(junk(:,1)<meandp/4,2)); if isempty(f4); f4=0; end;

stemp = share(1,:)';
stemp = stemp(idR);
stemp = stemp(abs(stddeltapR)>0 & abs(stddeltapR)<1);
stddeltapR = stddeltapR(abs(stddeltapR)>0 &  abs(stddeltapR)<1);
meandR = stemp'*abs(stddeltapR)/sum(stemp);
stddR  = sqrt(stemp'/sum(stemp)*(stddeltapR-stemp'*stddeltapR/sum(stemp)).^2);
kurtdR = stemp'/sum(stemp)*(stddeltapR-stemp'*stddeltapR/sum(stemp)).^4/stddR^4;

junk = [abs(stddeltapR),stemp];
junk = sortrows(junk,1);
junk(:,2) = cumsum(junk(:,2)/sum(junk(:,2)));

fR2 = max(junk(junk(:,1)<meandR/2,2));  if isempty(fR2); fR2=0; end;
fR4 = max(junk(junk(:,1)<meandR/4,2));  if isempty(fR4); fR4=0; end;


change = oldprices(2:end,:)~=oldprices(1:end-1,:);
change = change(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Fallchange = sum(change.*stemp)/sum(stemp);

changeT = (oldprices(2:end,:)~=prices(2:end,:) | oldprices(1:end-1,:)~=prices(1:end-1,:)& oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0) & ...
    oldprices(2:end,:)~=oldprices(1:end-1,:);
changeT = changeT(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Fractemp = sum(changeT.*stemp)/sum(stemp)/Fallchange;

changeR = prices(2:end,:)~=prices(1:end-1,:);
changeR = changeR(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Fregchange  = sum(changeR.*stemp)/sum(stemp);

temp = oldprices(1:end-1,:)~=prices(1:end-1,:);
temp = temp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Ftemp = sum(temp.*stemp)/sum(stemp);

ret = prices(2:end,:)==oldprices(2:end,:) & prices(1:end-1,:)~=oldprices(1:end-1,:);
ret = ret(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Fracret = sum(ret.*stemp)/sum(stemp)/Ftemp;

retold = (prices(2:end,:)==oldprices(2:end,:) & prices(1:end-1,:)~=oldprices(1:end-1,:)) & prices(2:end,:)==prices(1:end-1,:);
retold = retold(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Fracretold = sum(retold.*stemp)/sum(stemp)/Fracret/Ftemp;

tempbelow = oldprices(1:end-1,:) < prices(1:end-1,:);
tempbelow = tempbelow(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0);

stemp = share(2:end,:);
stemp = stemp(oldprices(2:end,:)>0&oldprices(1:end-1,:)>0);

Fbelow = sum(tempbelow.*stemp)/sum(stemp);



q = q(1:end-1,:);
soldbelow = q(oldprices(1:end-1,:) < prices(1:end-1,:) & oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0);
sold =      q(oldprices(2:end,:)>0 & oldprices(1:end-1,:)>0);

Fsoldbelow = sum(soldbelow)/sum(sold);

% Compute annual mode

lyear = 50;

modes=zeros(T/lyear,K);

fmode  = modes;
fbelow = modes;


for i=1:K
    
    for year=1:T/lyear % a year is 50 months
        
        junk=oldprices((year-1)*lyear+1:year*lyear,i);      % year = 12 months
        junk=junk(junk>0);
        if length(find(junk))>.6*lyear;                     % must be in at least 60% of the time
           
            modes(year,i)  = mode(junk);
            fmode(year,i)  = mean(junk==mode(junk));
            fbelow(year,i) = mean(junk<mode(junk));
                   
        end
    end
end

fmode  = fmode(modes>0);
fbelow = fbelow(modes>0);

stemp  = repmat(share(1,:),T/lyear,1);
stemp  = stemp(modes>0);

Fmode = stemp'/sum(stemp)*fmode;

Fbelowmode = stemp'/sum(stemp)*fbelow;

changeM = modes(2:end,:) ~= modes(1:end-1,:);
changeM = changeM(modes(2:end,:)>0&modes(1:end-1,:)>0);

stemp = repmat(share(1,:), T/lyear-1,1);
stemp = stemp(modes(2:end,:)>0 & modes(1:end-1,:)>0);

Fannualchanges = stemp'/sum(stemp)*changeM;

% Compute quarterly mode

lyear = 12;
T = T-4;
oldprices(1:4,:)=[];

modes=zeros(T/lyear,K);

fmode  = modes;
fbelow = modes;

for i=1:K
    
    for year=1:T/lyear % a year is 50 months
        
        junk=oldprices((year-1)*lyear+1:year*lyear,i);      % year = 12 months
        junk=junk(junk>0);
        if length(find(junk))>.6*lyear;                     % must be in at least 60% of the time
           
            modes(year,i)  = mode(junk);
            fmode(year,i)  = mean(junk==mode(junk));
            fbelow(year,i) = mean(junk<mode(junk));

       
        end
    end
end


fmode  = fmode(modes>0);
fbelow = fbelow(modes>0);

stemp  = repmat(share(1,:),T/lyear,1);
stemp  = stemp(modes>0);


Fqmode = stemp'/sum(stemp)*fmode;

Fbelowqmode = stemp'/sum(stemp)*fbelow;



changeM = modes(2:end,:) ~= modes(1:end-1,:);
changeM = changeM(modes(2:end,:)>0&modes(1:end-1,:)>0);

stemp = repmat(share(1,:), T/lyear-1,1);
stemp = stemp(modes(2:end,:)>0 & modes(1:end-1,:)>0);
Fquarterlychanges = stemp'/sum(stemp)*changeM;


fprintf('Frequency of price changes                                        = %9.3f  %9.3f \n', [Fallchange, 0.339]);
fprintf('Fraction of price changes that are temporary                      = %9.3f  %9.3f \n', [Fractemp, 0.965]);
fprintf('Frequency of reg price changes                                    = %9.3f  %9.3f \n', [Fregchange,0.029]);
fprintf('Probability temporary price spell ends                            = %9.3f  %9.3f \n', [Fracret,0.467]);
fprintf('Fraction of returns to old price                                  = %9.3f  %9.3f \n', [Fracretold, 0.858]);
fprintf('\n');
fprintf('\n');
fprintf('Fraction of periods with temporary prices                         = %9.3f  %9.3f \n', [Ftemp,0.250]);
fprintf('Fraction of prices below regular price                            = %9.3f  %9.3f \n', [Fbelow,0.215]);
fprintf('Fraction of goods below regular price                             = %9.3f  %9.3f \n', [Fsoldbelow, 0.370]);
fprintf('\n');
fprintf('\n');
fprintf('Fraction at annual mode                                           = %9.3f  %9.3f \n', [Fmode, 0.583 ]);
fprintf('Fraction below annual mode                                        = %9.3f  %9.3f \n', [Fbelowmode, 0.310]);
fprintf('Frequency with which annual mode changes                          = %9.3f  %9.3f \n', [Fannualchanges, 0.609]);
fprintf('\n');
fprintf('\n');
fprintf('Fraction at quarterly mode                                        = %9.3f  %9.3f \n', [Fqmode, 0.701]);
fprintf('Fraction below quarterly mode                                     = %9.3f  %9.3f \n', [Fbelowqmode, 0.223]);
fprintf('Frequency with which quarterly mode changes                       = %9.3f  %9.3f \n', [Fquarterlychanges, 0.323]);
fprintf('\n');
fprintf('\n');
fprintf('Size of price changes                                             = %9.3f  %9.3f \n',  [Meansize, 0.208]);
fprintf('S.d. size standardized delta p                                    = %9.3f  %9.3f \n', [SD,  0.184]);
fprintf('Kurtosis delta p                                                  = %9.3f  %9.3f \n', [kurtdp,  3.534]);
fprintf('Fraction abs delta p <1/2 mean                                    = %9.3f  %9.3f \n', [f2, 0.338]);
fprintf('Fraction abs delta p <1/4 mean                                    = %9.3f  %9.3f \n', [f4, 0.183]);
fprintf('\n');
fprintf('\n');
fprintf('Size of R price changes                                           = %9.3f  %9.3f  \n', [MeansizeR, 0.121]);
fprintf('S.d. size standardized delta pR                                   = %9.3f  %9.3f  \n', [SDR, 0.076]);
fprintf('Kurtosis delta pR                                                 = %9.3f  %9.3f \n', [kurtdR,  2.973]);
fprintf('Fraction abs delta pR <1/2 mean                                   = %9.3f  %9.3f \n', [fR2, 0.222]);
fprintf('Fraction abs delta pR <1/2 mean                                   = %9.3f  %9.3f \n', [fR4, 0.068]);
