#delimit;

clear; 
set mem 1500m;
set matsize 2000;
set more off;
cd ..;
cd "C:\projects\multi-product firms\Econometrica Replication Files\REPLICATION FILES\MAIN CODE\Table_6_8_data\";
use dominicks;


rename col1 date;
rename col2 good;
rename col3 upc;
rename col4 cat;
rename col5 p;
rename col6 pR;
rename col7 q;
rename col8 c;


sort good date;
xtset good date;

g adj = p~=L.p;
replace adj = . if L.p==. | p==.;
g adjR = pR~=L.pR ;
replace adjR =. if L.pR==. | pR ==.;

g man=floor(upc/100000);  /*this is not really manufacturer, as 1st digit may be non-zero */
replace man=man-floor(man/100000)*100000 if man>100000;
drop if man==0; /*funny upc codes: generic cigarettes and products without brand etc. Notice this means fewer price changes (~ 10,000) than in Table 1 */


egen cost = filter(c), coef(1 1 1 1) lags(-3/0) normalise;
replace c = cost;

g change = ln(p/L.p);
g achange = abs(change);
g changeR = ln(pR/L.pR);
g achangeR = abs(changeR);
g markup = L.p/c;
g markupR = L.pR/c;

egen meanmarkup = mean(markup), by(good);
egen meanmarkupR = mean(markupR), by(good);

g lnmeanmarkupR = ln(meanmarkupR);
g lnmeanmarkup = ln(meanmarkup);

g dev =  ln(markup/meanmarkup);
g devR = ln(markupR/meanmarkupR);

drop if dev>1 | devR > 1 | dev<-1 | devR<-1;

egen share = sum(q), by(good);

sum dev [aweight = share], d;
sum devR [aweight = share], d;

g Deltac = ln(c/L.c);
drop if Deltac >1 | Deltac< -1;
sum Deltac[aweight = share], d;
