clear;
clc;
format short;

global gamma mua;

%Assigned Parameters: 
   
gamma  = 3;                % elasticity between retailers
mua    = 0;  
ha     = 0;

sa     = 0.1008;           % max size productivity shocks
saa    = 0.9985;           % covariance of productivity shocks (weight on mean)
phiR   = 0.0168;          % menu costs for regular prices
pshock = 0.0381;

            

%Bounds for parameters:

lb = [0.07; 0.6; 0.005; 0.01];          
ub = [0.14; 1.5; 0.020; 0.08];

%guess for calibrated parameters 

xstart=[sa; saa; phiR; pshock];

% objective(xstart)
%  break
% Code for use by Tomlab
% Name = 'Model 1';
% Prob = glcAssign('objective',lb,ub,Name);
% tomRun('ego',Prob,3)

i = 2;

if i==1
x = fmincon('objective',xstart,[],[],[],[],lb,ub);
    else
x = neldmead_bounds('objective',xstart,lb,ub);
end

save x x
